Index: /orxonox/branches/chris/sound_test/sound_control.cc
===================================================================
--- /orxonox/branches/chris/sound_test/sound_control.cc	(revision 3102)
+++ /orxonox/branches/chris/sound_test/sound_control.cc	(revision 3102)
@@ -0,0 +1,200 @@
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+   
+   Copyright (C) 2004 orx
+   
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+   
+   ### File Specific:
+   main-programmer: Simon Hofmann 
+   co-programmer:
+*/
+
+#include "sound_control.h"
+
+using namespace std;
+
+SoundControl* SoundControl::instance = NULL;
+int volume = SDL_MIX_MAXVOLUME;
+int track_number = 1;
+static Mix_Music* music = NULL;
+int audio_rate = MIX_DEFAULT_FREQUENCY, audio_channels = MIX_DEFAULT_CHANNELS, audio_buffers = 16384, bits = 0; 
+Uint16 audio_format = MIX_DEFAULT_FORMAT;
+
+
+/** 
+    \brief standard constructor 
+    
+    This constructor builds a SoundControl Object, which waits for callers.
+    All sound output is handled by this singleton object.
+*/ 
+SoundControl::SoundControl () { 
+
+  /*
+  initializing sound and calling Mix_OpenAudio 
+  if(SDL_Init(SDL_INIT_AUDIO)<0){ 
+    printf("SDL_Init: INIT_AUDIO error.\n"); 
+  } 
+  */
+  
+  if(Mix_OpenAudio(audio_rate, audio_format, audio_channels, audio_buffers)){ 
+    printf("Mix_OpenAudio: Failed to open audio!\n"); 
+  } 
+  
+  initialise();
+}
+
+
+/** 
+    \brief Default destructor 
+*/ 
+SoundControl::~SoundControl () { 
+}
+
+/**
+   \brief Returns a reference to the singleton
+*/
+SoundControl* SoundControl::getInstance() {
+  if (instance == NULL) {
+    instance = new SoundControl;
+  }
+  return instance;
+}
+
+void SoundControl::deleteInstance() {
+  delete instance;
+  instance = NULL;
+}
+
+/** 
+    \brief Is called by SoundControl object to initiate all values 
+*/ 
+void SoundControl::initialise() { 
+  
+  // Print some info 
+  Mix_QuerySpec(&audio_rate, &audio_format, &audio_channels); 
+  bits=audio_format&0xFF; 
+  printf("Opened audio at %d Hz %d bit %s, %d bytes audio buffer\n", audio_rate, bits, audio_channels > 1 ? "stereo" : "mono", audio_buffers ); 
+  Mix_VolumeMusic(volume);
+} 
+
+
+/** 
+    \brief Sets the number of output Channels (should not be used)
+*/ 
+void SoundControl::setNumberOfChannels (int number_of_channels) { 
+  Mix_AllocateChannels(number_of_channels);
+} 
+
+
+/** 
+    \brief May be called from any WorldEntity to play a .xm file 
+    \param filename: self-explanatory 
+*/ 
+int SoundControl::playMod (char* fileName) {
+  Mix_Chunk* chunk = NULL; 
+  chunk = Mix_LoadWAV(fileName); 
+  if(Mix_PlayChannel(-1, chunk, 0) == -1) {
+    printf("Mix_PlayChannel: %s\n", Mix_GetError());
+  }
+}
+
+
+/** 
+    \brief May be called from any WorldEntity to play a .wav file 
+    \param filename: self-explanatory 
+*/ 
+int SoundControl::playWav (char* fileName) {
+  Mix_Chunk* chunk = NULL; 
+  chunk = Mix_LoadWAV(fileName); 
+  if(Mix_PlayChannel(-1, chunk, 0) == -1) {
+    printf("Mix_PlayChannel: %s\n", Mix_GetError());
+  }
+} 
+
+
+/** 
+    \brief May be called from any WorldEntity to play a .ogg file 
+    \param filename: self-explanatory 
+*/ 
+int SoundControl::playOgg (char* fileName) {
+  Mix_Music* music = NULL;
+  music = Mix_LoadMUS(fileName);
+  if(Mix_PlayMusic(music, 1) == -1){
+    printf("Mix_PlayMusic: %s\n",Mix_GetError());
+  }
+  Mix_HookMusicFinished(musicDone);
+} 
+
+
+/** 
+    \brief Heightens the overall volume of output 
+*/ 
+void SoundControl::volumeUp () { 
+  volume = (volume + 1) << 1; 
+  if(volume > SDL_MIX_MAXVOLUME) 
+    volume = SDL_MIX_MAXVOLUME; 
+  Mix_VolumeMusic(volume); 
+} 
+
+
+/** 
+    \brief Lowers the overall volume of output 
+*/  
+void SoundControl::volumeDown () { 
+  volume >>= 1; 
+  Mix_VolumeMusic(volume); 
+} 
+
+
+/** 
+    \brief Rewinds music to the beginning 
+*/  
+void SoundControl::trackRewind () { 
+  Mix_RewindMusic(); 
+} 
+
+
+/** 
+    \brief Rewinds the music 5 seconds 
+*/  
+void SoundControl::forwardMusic () { 
+  Mix_SetMusicPosition(+5); 
+} 
+
+
+/** 
+    \brief Forwards the music 5 seconds 
+*/  
+void SoundControl::rewindMusic () { 
+  Mix_SetMusicPosition(-5); 
+} 
+
+
+/** 
+    \brief Pauses music output 
+*/ 
+void SoundControl::pauseMusic () {
+  Mix_PauseMusic();
+} 
+
+
+/** 
+    \brief this function pauses music output 
+*/ 
+void SoundControl::resumeMusic () {
+  Mix_ResumeMusic();
+} 
+
+
+/** 
+    \brief Hooked by playOgg at end of .ogg playback
+*/ 
+void SoundControl::musicDone() {
+  Mix_HaltMusic();
+  Mix_FreeMusic(music);
+  music = NULL;
+} 
Index: /orxonox/branches/chris/sound_test/sound_control.h
===================================================================
--- /orxonox/branches/chris/sound_test/sound_control.h	(revision 3102)
+++ /orxonox/branches/chris/sound_test/sound_control.h	(revision 3102)
@@ -0,0 +1,40 @@
+#ifndef SOUNDCONTROL_CLASS_H
+#define SOUNDCONTROL_CLASS_H
+
+#include "SDL/SDL.h"
+#include "SDL/SDL_mixer.h"
+#include <stdio.h>
+
+class SoundControl {
+
+ public:
+  static SoundControl* getInstance();
+  static void deleteInstance();
+  void setNumberOfChannels(int number_of_channels);
+  int playMod(char* filename);
+  int playWav(char* filename);
+  int playOgg(char* filename);
+  void volumeUp();
+  void volumeDown();
+  void trackRewind();
+  void forwardMusic();
+  void rewindMusic();
+  void pauseMusic();
+  void resumeMusic();
+  static void musicDone();
+  int volume;
+  int track_number;
+  int audio_rate, audio_channels, audio_buffers;
+  int done;
+  Uint16 audio_format;
+
+protected:
+  void initialise();
+  SoundControl();
+  ~SoundControl();
+
+private:
+  static SoundControl* instance;
+};
+
+#endif
Index: /orxonox/branches/chris/sound_test/sound_test.cc
===================================================================
--- /orxonox/branches/chris/sound_test/sound_test.cc	(revision 3102)
+++ /orxonox/branches/chris/sound_test/sound_test.cc	(revision 3102)
@@ -0,0 +1,97 @@
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Simon Hofmann
+   co-programmer:
+*/
+
+#include "sound_test.h"
+
+static Mix_Music* music = NULL;
+
+using namespace std;
+
+void handleKey(SDL_KeyboardEvent key);
+
+SoundControl* sound = NULL;
+int sfx_channel1 = -1;
+int sfx_channel2 = -1;
+int finished = 0;
+
+SoundTest::SoundTest() {
+  sound = SoundControl::getInstance();
+}
+
+SoundTest::~SoundTest() {
+  sound->deleteInstance();
+}
+
+int main( int argc, char* argv[] ) {
+  SoundTest();
+  SDL_Surface *screen;
+  SDL_Event event;
+  SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO); 
+  screen = SDL_SetVideoMode(320, 240, 0, 0);
+  while(!finished) {
+    while(SDL_PollEvent(&event)) {
+      switch(event.type) {
+      case SDL_QUIT:
+	finished = 1;
+	break;
+      case SDL_KEYDOWN:
+      case SDL_KEYUP:
+	handleKey(event.key);
+	break;
+      }
+    }
+    SDL_Delay(50);
+  }
+  SDL_Quit();
+}
+
+void handleKey(SDL_KeyboardEvent key) {
+  switch(key.keysym.sym) {
+  case SDLK_a:
+    if(key.type == SDL_KEYDOWN) {
+      if(sfx_channel1 < 0) {
+	sfx_channel1 = sound->playWav("sound1.wav");
+      }
+    } else {
+      Mix_HaltChannel(sfx_channel1);
+      sfx_channel1 = -1;
+    }
+    break;
+  case SDLK_s:
+    if(key.type == SDL_KEYDOWN) {
+      if(sfx_channel2 < 0) {
+	sfx_channel2 = sound->playWav("sound2.wav");
+      }
+    } else {
+      Mix_HaltChannel(sfx_channel2);
+      sfx_channel2 = -1;
+    }
+    break;
+  case SDLK_m:
+    if(key.state == SDL_PRESSED) {
+      if(music == NULL) { 
+	sound->playOgg("music.ogg");
+      } else {
+	Mix_HaltMusic();
+	Mix_FreeMusic(music);
+	music = NULL;
+      }
+    }
+    break;
+  case SDLK_q:
+    finished = 1;
+    break;
+  }
+}
Index: /orxonox/branches/chris/sound_test/sound_test.h
===================================================================
--- /orxonox/branches/chris/sound_test/sound_test.h	(revision 3102)
+++ /orxonox/branches/chris/sound_test/sound_test.h	(revision 3102)
@@ -0,0 +1,21 @@
+#ifndef SOUND_TEST_H
+#define SOUND_TEST_H
+
+#include <SDL/SDL.h>
+#include <SDL/SDL_mixer.h>
+#include "sound_control.h"
+
+class SoundTest {
+
+ public:
+  SoundTest();
+  ~SoundTest();
+  int main (void);
+  void handleKey(SDL_KeyboardEvent key);
+  SoundControl* sound;
+  int sfx_channel1;
+  int sfx_channel2;
+  int finished;
+};
+
+#endif