Index: /orxonox/branches/images/Makefile.am
===================================================================
--- /orxonox/branches/images/Makefile.am	(revision 3104)
+++ /orxonox/branches/images/Makefile.am	(revision 3105)
@@ -1,1 +1,7 @@
-SUBDIRS = src console gui importer
+if HAVE_GTK2
+  GTK_PROGS =gui console
+else
+  GTK_PROGS =
+endif
+
+SUBDIRS = src importer $(GTK_PROGS)
Index: /orxonox/branches/images/Makefile.in
===================================================================
--- /orxonox/branches/images/Makefile.in	(revision 3104)
+++ /orxonox/branches/images/Makefile.in	(revision 3105)
@@ -60,5 +60,5 @@
 ETAGS = etags
 CTAGS = ctags
-DIST_SUBDIRS = $(SUBDIRS)
+DIST_SUBDIRS = src importer gui console
 DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
 distdir = $(PACKAGE)-$(VERSION)
@@ -118,5 +118,4 @@
 PACKAGE_VERSION = @PACKAGE_VERSION@
 PATH_SEPARATOR = @PATH_SEPARATOR@
-PKG_CONFIG = @PKG_CONFIG@
 SET_MAKE = @SET_MAKE@
 SHELL = @SHELL@
@@ -165,5 +164,7 @@
 target_os = @target_os@
 target_vendor = @target_vendor@
-SUBDIRS = src console gui importer
+@HAVE_GTK2_FALSE@GTK_PROGS = 
+@HAVE_GTK2_TRUE@GTK_PROGS = gui console
+SUBDIRS = src importer $(GTK_PROGS)
 all: config.h
 	$(MAKE) $(AM_MAKEFLAGS) all-recursive
@@ -371,5 +372,5 @@
 	  fi; \
 	done
-	list='$(SUBDIRS)'; for subdir in $$list; do \
+	list='$(DIST_SUBDIRS)'; for subdir in $$list; do \
 	  if test "$$subdir" = .; then :; else \
 	    test -d "$(distdir)/$$subdir" \
Index: /orxonox/branches/images/aclocal.m4
===================================================================
--- /orxonox/branches/images/aclocal.m4	(revision 3104)
+++ /orxonox/branches/images/aclocal.m4	(revision 3105)
@@ -11,62 +11,4 @@
 # even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 # PARTICULAR PURPOSE.
-
-
-dnl PKG_CHECK_MODULES(GSTUFF, gtk+-2.0 >= 1.3 glib = 1.3.4, action-if, action-not)
-dnl defines GSTUFF_LIBS, GSTUFF_CFLAGS, see pkg-config man page
-dnl also defines GSTUFF_PKG_ERRORS on error
-AC_DEFUN(PKG_CHECK_MODULES, [
-  succeeded=no
-
-  if test -z "$PKG_CONFIG"; then
-    AC_PATH_PROG(PKG_CONFIG, pkg-config, no)
-  fi
-
-  if test "$PKG_CONFIG" = "no" ; then
-     echo "*** The pkg-config script could not be found. Make sure it is"
-     echo "*** in your path, or set the PKG_CONFIG environment variable"
-     echo "*** to the full path to pkg-config."
-     echo "*** Or see http://www.freedesktop.org/software/pkgconfig to get pkg-config."
-  else
-     PKG_CONFIG_MIN_VERSION=0.9.0
-     if $PKG_CONFIG --atleast-pkgconfig-version $PKG_CONFIG_MIN_VERSION; then
-        AC_MSG_CHECKING(for $2)
-
-        if $PKG_CONFIG --exists "$2" ; then
-            AC_MSG_RESULT(yes)
-            succeeded=yes
-
-            AC_MSG_CHECKING($1_CFLAGS)
-            $1_CFLAGS=`$PKG_CONFIG --cflags "$2"`
-            AC_MSG_RESULT($$1_CFLAGS)
-
-            AC_MSG_CHECKING($1_LIBS)
-            $1_LIBS=`$PKG_CONFIG --libs "$2"`
-            AC_MSG_RESULT($$1_LIBS)
-        else
-            $1_CFLAGS=""
-            $1_LIBS=""
-            ## If we have a custom action on failure, don't print errors, but 
-            ## do set a variable so people can do so.
-            $1_PKG_ERRORS=`$PKG_CONFIG --errors-to-stdout --print-errors "$2"`
-            ifelse([$4], ,echo $$1_PKG_ERRORS,)
-        fi
-
-        AC_SUBST($1_CFLAGS)
-        AC_SUBST($1_LIBS)
-     else
-        echo "*** Your version of pkg-config is too old. You need version $PKG_CONFIG_MIN_VERSION or newer."
-        echo "*** See http://www.freedesktop.org/software/pkgconfig"
-     fi
-  fi
-
-  if test $succeeded = yes; then
-     ifelse([$3], , :, [$3])
-  else
-     ifelse([$4], , AC_MSG_ERROR([Library requirements ($2) not met; consider adjusting the PKG_CONFIG_PATH environment variable if your libraries are in a nonstandard prefix so pkg-config can find them.]), [$4])
-  fi
-])
-
-
 
 #                                                        -*- Autoconf -*-
Index: /orxonox/branches/images/config.h.in
===================================================================
--- /orxonox/branches/images/config.h.in	(revision 3104)
+++ /orxonox/branches/images/config.h.in	(revision 3105)
@@ -9,4 +9,7 @@
 /* Define to 1 if you have the <GL/gl.h> header file. */
 #undef HAVE_GL_GL_H
+
+/* if we have GTK2 */
+#undef HAVE_GTK2
 
 /* Define to 1 if you have the <inttypes.h> header file. */
Index: /orxonox/branches/images/configure
===================================================================
--- /orxonox/branches/images/configure	(revision 3104)
+++ /orxonox/branches/images/configure	(revision 3105)
@@ -312,5 +312,5 @@
 #endif"
 
-ac_subst_vars='SHELL PATH_SEPARATOR PACKAGE_NAME PACKAGE_TARNAME PACKAGE_VERSION PACKAGE_STRING PACKAGE_BUGREPORT exec_prefix prefix program_transform_name bindir sbindir libexecdir datadir sysconfdir sharedstatedir localstatedir libdir includedir oldincludedir infodir mandir build_alias host_alias target_alias DEFS ECHO_C ECHO_N ECHO_T LIBS build build_cpu build_vendor build_os host host_cpu host_vendor host_os target target_cpu target_vendor target_os INSTALL_PROGRAM INSTALL_SCRIPT INSTALL_DATA CYGPATH_W PACKAGE VERSION ACLOCAL AUTOCONF AUTOMAKE AUTOHEADER MAKEINFO AMTAR install_sh STRIP ac_ct_STRIP INSTALL_STRIP_PROGRAM mkdir_p AWK SET_MAKE am__leading_dot CXX CXXFLAGS LDFLAGS CPPFLAGS ac_ct_CXX EXEEXT OBJEXT DEPDIR am__include am__quote AMDEP_TRUE AMDEP_FALSE AMDEPBACKSLASH CXXDEPMODE am__fastdepCXX_TRUE am__fastdepCXX_FALSE CC CFLAGS ac_ct_CC CCDEPMODE am__fastdepCC_TRUE am__fastdepCC_FALSE CPP EGREP MSBITFIELDS PKG_CONFIG GTK2_CFLAGS GTK2_LIBS HAVE_GTK2_TRUE HAVE_GTK2_FALSE LIBOBJS LTLIBOBJS'
+ac_subst_vars='SHELL PATH_SEPARATOR PACKAGE_NAME PACKAGE_TARNAME PACKAGE_VERSION PACKAGE_STRING PACKAGE_BUGREPORT exec_prefix prefix program_transform_name bindir sbindir libexecdir datadir sysconfdir sharedstatedir localstatedir libdir includedir oldincludedir infodir mandir build_alias host_alias target_alias DEFS ECHO_C ECHO_N ECHO_T LIBS build build_cpu build_vendor build_os host host_cpu host_vendor host_os target target_cpu target_vendor target_os INSTALL_PROGRAM INSTALL_SCRIPT INSTALL_DATA CYGPATH_W PACKAGE VERSION ACLOCAL AUTOCONF AUTOMAKE AUTOHEADER MAKEINFO AMTAR install_sh STRIP ac_ct_STRIP INSTALL_STRIP_PROGRAM mkdir_p AWK SET_MAKE am__leading_dot CXX CXXFLAGS LDFLAGS CPPFLAGS ac_ct_CXX EXEEXT OBJEXT DEPDIR am__include am__quote AMDEP_TRUE AMDEP_FALSE AMDEPBACKSLASH CXXDEPMODE am__fastdepCXX_TRUE am__fastdepCXX_FALSE CC CFLAGS ac_ct_CC CCDEPMODE am__fastdepCC_TRUE am__fastdepCC_FALSE CPP EGREP MSBITFIELDS GTK2_LIBS GTK2_CFLAGS HAVE_GTK2_TRUE HAVE_GTK2_FALSE LIBOBJS LTLIBOBJS'
 ac_subst_files=''
 
@@ -865,4 +865,6 @@
   --disable-dependency-tracking  speeds up one-time build
   --enable-dependency-tracking   do not reject slow dependency extractors
+  --disable-gtk           Prevents GTK from being loaded
+  --disabel-sdl-image     Prevents SDL_image from being loaded
 
 Some influential environment variables:
@@ -3830,4 +3832,37 @@
 
 
+
+### CHECKING  OPTIONAT ARGUMENTS
+## GTK-disabled
+def_gtk=yes
+echo "$as_me:$LINENO: checking if gtk should be enabled" >&5
+echo $ECHO_N "checking if gtk should be enabled... $ECHO_C" >&6
+# Check whether --enable-gtk or --disable-gtk was given.
+if test "${enable_gtk+set}" = set; then
+  enableval="$enable_gtk"
+  def_gtk=no
+fi;
+if test "$def_gtk" = yes; then
+  echo "yes"
+fi
+if test "$def_gtk" = no; then
+  echo "no"
+fi
+### SDL_image-disable
+def_sdl_image=yes
+echo "$as_me:$LINENO: checking if SDL_image should be enabled" >&5
+echo $ECHO_N "checking if SDL_image should be enabled... $ECHO_C" >&6
+# Check whether --enable-sdl_image or --disable-sdl_image was given.
+if test "${enable_sdl_image+set}" = set; then
+  enableval="$enable_sdl_image"
+  def_sdl_image=no
+fi;
+if test "$def_sdl_image" = yes; then
+  echo "yes"
+fi
+if test "$def_sdl_image" = no; then
+  echo "no"
+fi
+
 ### CHECKING FOR SYSTEM ###
 
@@ -4744,5 +4779,5 @@
     fi
 
-
+    def_sdl_image=no;
     ;;
 
@@ -5445,4 +5480,6 @@
      fi
 
+## check for SDL_Image
+if test "$def_sdl_image" = "yes"; then
 # checking for SDL_image-headers
 
@@ -5593,11 +5630,11 @@
 
 else
-  { { echo "$as_me:$LINENO: error: cannot find SDL_image headers" >&5
-echo "$as_me: error: cannot find SDL_image headers" >&2;}
-   { (exit 1); exit 1; }; }
+  echo "sdl_image not found. falling back to other options"; def_sdl_image=no
 fi
 
 done
 
+fi
+if test "$def_sdl_image" = "yes"; then
 # checking for SDL_image-lib
   echo "$as_me:$LINENO: checking for main in -lSDL_image" >&5
@@ -5672,4 +5709,5 @@
         exit -1
      fi
+fi
 
 ## checking for SDL
@@ -6017,4 +6055,6 @@
        CXXFLAGS="$CXXFLAGS $SDL_CFLAGS"
        LIBS="$LIBS $SDL_LIBS"
+
+       def_sdl_image=no;
     ;;
 
@@ -6025,5 +6065,6 @@
 
 
-## checking for libjpeg
+if test "$def_sdl_image" = "no"; then
+ ## checking for libjpeg
 
 for ac_header in jpeglib.h
@@ -6181,5 +6222,5 @@
 
 
-echo "$as_me:$LINENO: checking for main in -ljpeg" >&5
+ echo "$as_me:$LINENO: checking for main in -ljpeg" >&5
 echo $ECHO_N "checking for main in -ljpeg... $ECHO_C" >&6
 if test "${ac_cv_lib_jpeg_main+set}" = set; then
@@ -6254,5 +6295,5 @@
 
 
-## checking for libpng
+ ## checking for libpng
 
 for ac_header in png.h
@@ -6410,5 +6451,5 @@
 
 
-echo "$as_me:$LINENO: checking for main in -lpng" >&5
+ echo "$as_me:$LINENO: checking for main in -lpng" >&5
 echo $ECHO_N "checking for main in -lpng... $ECHO_C" >&6
 if test "${ac_cv_lib_png_main+set}" = set; then
@@ -6481,108 +6522,32 @@
 	 exit -1
     fi
-
+fi
 
 ## checking for GTK
-
-  succeeded=no
-
-  if test -z "$PKG_CONFIG"; then
-    # Extract the first word of "pkg-config", so it can be a program name with args.
-set dummy pkg-config; ac_word=$2
-echo "$as_me:$LINENO: checking for $ac_word" >&5
-echo $ECHO_N "checking for $ac_word... $ECHO_C" >&6
-if test "${ac_cv_path_PKG_CONFIG+set}" = set; then
-  echo $ECHO_N "(cached) $ECHO_C" >&6
-else
-  case $PKG_CONFIG in
-  [\\/]* | ?:[\\/]*)
-  ac_cv_path_PKG_CONFIG="$PKG_CONFIG" # Let the user override the test with a path.
-  ;;
-  *)
-  as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
-for as_dir in $PATH
-do
-  IFS=$as_save_IFS
-  test -z "$as_dir" && as_dir=.
-  for ac_exec_ext in '' $ac_executable_extensions; do
-  if $as_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
-    ac_cv_path_PKG_CONFIG="$as_dir/$ac_word$ac_exec_ext"
-    echo "$as_me:$LINENO: found $as_dir/$ac_word$ac_exec_ext" >&5
-    break 2
-  fi
-done
-done
-
-  test -z "$ac_cv_path_PKG_CONFIG" && ac_cv_path_PKG_CONFIG="no"
-  ;;
-esac
-fi
-PKG_CONFIG=$ac_cv_path_PKG_CONFIG
-
-if test -n "$PKG_CONFIG"; then
-  echo "$as_me:$LINENO: result: $PKG_CONFIG" >&5
-echo "${ECHO_T}$PKG_CONFIG" >&6
-else
-  echo "$as_me:$LINENO: result: no" >&5
-echo "${ECHO_T}no" >&6
-fi
-
-  fi
-
-  if test "$PKG_CONFIG" = "no" ; then
-     echo "*** The pkg-config script could not be found. Make sure it is"
-     echo "*** in your path, or set the PKG_CONFIG environment variable"
-     echo "*** to the full path to pkg-config."
-     echo "*** Or see http://www.freedesktop.org/software/pkgconfig to get pkg-config."
-  else
-     PKG_CONFIG_MIN_VERSION=0.9.0
-     if $PKG_CONFIG --atleast-pkgconfig-version $PKG_CONFIG_MIN_VERSION; then
-        echo "$as_me:$LINENO: checking for gtk+-2.0 >= 2.0.3 gthread-2.0 >= 2.0.3" >&5
-echo $ECHO_N "checking for gtk+-2.0 >= 2.0.3 gthread-2.0 >= 2.0.3... $ECHO_C" >&6
-
-        if $PKG_CONFIG --exists "gtk+-2.0 >= 2.0.3 gthread-2.0 >= 2.0.3" ; then
-            echo "$as_me:$LINENO: result: yes" >&5
-echo "${ECHO_T}yes" >&6
-            succeeded=yes
-
-            echo "$as_me:$LINENO: checking GTK2_CFLAGS" >&5
-echo $ECHO_N "checking GTK2_CFLAGS... $ECHO_C" >&6
-            GTK2_CFLAGS=`$PKG_CONFIG --cflags "gtk+-2.0 >= 2.0.3 gthread-2.0 >= 2.0.3"`
-            echo "$as_me:$LINENO: result: $GTK2_CFLAGS" >&5
-echo "${ECHO_T}$GTK2_CFLAGS" >&6
-
-            echo "$as_me:$LINENO: checking GTK2_LIBS" >&5
-echo $ECHO_N "checking GTK2_LIBS... $ECHO_C" >&6
-            GTK2_LIBS=`$PKG_CONFIG --libs "gtk+-2.0 >= 2.0.3 gthread-2.0 >= 2.0.3"`
-            echo "$as_me:$LINENO: result: $GTK2_LIBS" >&5
-echo "${ECHO_T}$GTK2_LIBS" >&6
-        else
-            GTK2_CFLAGS=""
-            GTK2_LIBS=""
-            ## If we have a custom action on failure, don't print errors, but
-            ## do set a variable so people can do so.
-            GTK2_PKG_ERRORS=`$PKG_CONFIG --errors-to-stdout --print-errors "gtk+-2.0 >= 2.0.3 gthread-2.0 >= 2.0.3"`
-
-        fi
-
-
-
-     else
-        echo "*** Your version of pkg-config is too old. You need version $PKG_CONFIG_MIN_VERSION or newer."
-        echo "*** See http://www.freedesktop.org/software/pkgconfig"
-     fi
-  fi
-
-  if test $succeeded = yes; then
-     have_gtk2=yes
-  else
-     have_gtk2=no
-  fi
-
-
-
-
-
-if test "x$have_gtk2" = xyes; then
+if test "$def_gtk" = yes; then
+
+	#PKG_CHECK_MODULES(GTK2, gtk+-2.0 >= 2.0.3 gthread-2.0 >= 2.0.3, have_gtk2=yes, have_gtk2=no)
+	echo "$as_me:$LINENO: checking for gtk2.0" >&5
+echo $ECHO_N "checking for gtk2.0... $ECHO_C" >&6
+	if `pkg-config --exists gtk+-2.0`; then
+  		echo "yes"
+  		have_gtk2=yes
+		GTK2_LIBS=`pkg-config --libs gtk+-2.0`
+		GTK2_CFLAGS=`pkg-config --cflags gtk+-2.0`
+
+cat >>confdefs.h <<_ACEOF
+#define HAVE_GTK2 1
+_ACEOF
+
+	else
+		echo "no"
+	fi
+
+fi
+
+
+
+
+if test x$have_gtk2 = xyes; then
   HAVE_GTK2_TRUE=
   HAVE_GTK2_FALSE='#'
@@ -6591,4 +6556,5 @@
   HAVE_GTK2_FALSE=
 fi
+
 
 
@@ -8262,7 +8228,6 @@
 s,@EGREP@,$EGREP,;t t
 s,@MSBITFIELDS@,$MSBITFIELDS,;t t
-s,@PKG_CONFIG@,$PKG_CONFIG,;t t
+s,@GTK2_LIBS@,$GTK2_LIBS,;t t
 s,@GTK2_CFLAGS@,$GTK2_CFLAGS,;t t
-s,@GTK2_LIBS@,$GTK2_LIBS,;t t
 s,@HAVE_GTK2_TRUE@,$HAVE_GTK2_TRUE,;t t
 s,@HAVE_GTK2_FALSE@,$HAVE_GTK2_FALSE,;t t
Index: /orxonox/branches/images/configure.ac
===================================================================
--- /orxonox/branches/images/configure.ac	(revision 3104)
+++ /orxonox/branches/images/configure.ac	(revision 3105)
@@ -20,4 +20,31 @@
 AC_PROG_CXX
 AC_HEADER_STDC
+
+
+### CHECKING  OPTIONAT ARGUMENTS
+## GTK-disabled
+def_gtk=yes
+AC_MSG_CHECKING([if gtk should be enabled])
+AC_ARG_ENABLE([gtk], 
+	AC_HELP_STRING(	[--disable-gtk], 
+	[Prevents GTK from being loaded]), [def_gtk=no]) 
+if test "$def_gtk" = yes; then 
+  echo "yes"
+fi 
+if test "$def_gtk" = no; then 
+  echo "no"
+fi
+### SDL_image-disable
+def_sdl_image=yes
+AC_MSG_CHECKING([if SDL_image should be enabled])
+AC_ARG_ENABLE([sdl_image], 
+	AC_HELP_STRING(	[--disabel-sdl-image], 
+	[Prevents SDL_image from being loaded]), [def_sdl_image=no]) 
+if test "$def_sdl_image" = yes; then 
+  echo "yes"
+fi 
+if test "$def_sdl_image" = no; then 
+  echo "no"
+fi
 
 ### CHECKING FOR SYSTEM ###
@@ -99,5 +126,5 @@
     fi
 
-
+    def_sdl_image=no;
     ;;
 
@@ -155,7 +182,11 @@
      fi   
 
+## check for SDL_Image
+if test "$def_sdl_image" = "yes"; then
 # checking for SDL_image-headers
   AC_CHECK_HEADERS(SDL/SDL_image.h ,,
-      [AC_MSG_ERROR([cannot find SDL_image headers]) ])
+      [echo "sdl_image not found. falling back to other options"; def_sdl_image=no ])
+fi
+if test "$def_sdl_image" = "yes"; then
 # checking for SDL_image-lib
   AC_CHECK_LIB([SDL_image], [main], FOUND_SDL_image=yes)
@@ -169,4 +200,5 @@
         exit -1
      fi   
+fi
 
 ## checking for SDL
@@ -210,4 +242,6 @@
        CXXFLAGS="$CXXFLAGS $SDL_CFLAGS"
        LIBS="$LIBS $SDL_LIBS"
+
+       def_sdl_image=no;
     ;;
 
@@ -218,9 +252,10 @@
 AC_SUBST(MSBITFIELDS)
 
-## checking for libjpeg
-AC_CHECK_HEADERS(jpeglib.h ,,
+if test "$def_sdl_image" = "no"; then
+ ## checking for libjpeg
+ AC_CHECK_HEADERS(jpeglib.h ,,
         [AC_MSG_ERROR([cannot find jpeg headers]) ])
 
-AC_CHECK_LIB([jpeg], [main], FOUND_jpeg=yes)
+ AC_CHECK_LIB([jpeg], [main], FOUND_jpeg=yes)
     if test "$FOUND_jpeg" = "yes" ; then
       LIBS="$LIBS -ljpeg"
@@ -234,9 +269,9 @@
 
 
-## checking for libpng
-AC_CHECK_HEADERS(png.h ,,
+ ## checking for libpng
+ AC_CHECK_HEADERS(png.h ,,
         [AC_MSG_ERROR([cannot find jpeg headers]) ])
 
-AC_CHECK_LIB([png], [main], FOUND_png=yes)
+ AC_CHECK_LIB([png], [main], FOUND_png=yes)
     if test "$FOUND_png" = "yes" ; then
       LIBS="$LIBS -lpng"
@@ -248,11 +283,26 @@
 	 exit -1
     fi   
-
+fi
 
 ## checking for GTK
-PKG_CHECK_MODULES(GTK2, gtk+-2.0 >= 2.0.3 gthread-2.0 >= 2.0.3, have_gtk2=yes, have_gtk2=no)
+if test "$def_gtk" = yes; then 
+
+	#PKG_CHECK_MODULES(GTK2, gtk+-2.0 >= 2.0.3 gthread-2.0 >= 2.0.3, have_gtk2=yes, have_gtk2=no)
+	AC_MSG_CHECKING([for gtk2.0])
+	if `pkg-config --exists gtk+-2.0`; then
+  		echo "yes"
+  		have_gtk2=yes
+		GTK2_LIBS=`pkg-config --libs gtk+-2.0`
+		GTK2_CFLAGS=`pkg-config --cflags gtk+-2.0`
+		AC_DEFINE_UNQUOTED(HAVE_GTK2, 1, [if we have GTK2])
+	else
+		echo "no"
+	fi
+
+fi
 AC_SUBST(GTK2_LIBS)
 AC_SUBST(GTK2_CFLAGS)
-AM_CONDITIONAL(HAVE_GTK2, test "x$have_gtk2" = xyes)
+AM_CONDITIONAL(HAVE_GTK2, test x$have_gtk2 = xyes)
+
 
 
@@ -267,5 +317,5 @@
  AC_CHECK_LIB([m], [main])
 
-
+ 
 # Checks for header files.
 AC_HEADER_STDC
Index: /orxonox/branches/images/console/Makefile.in
===================================================================
--- /orxonox/branches/images/console/Makefile.in	(revision 3104)
+++ /orxonox/branches/images/console/Makefile.in	(revision 3105)
@@ -121,5 +121,4 @@
 PACKAGE_VERSION = @PACKAGE_VERSION@
 PATH_SEPARATOR = @PATH_SEPARATOR@
-PKG_CONFIG = @PKG_CONFIG@
 SET_MAKE = @SET_MAKE@
 SHELL = @SHELL@
Index: /orxonox/branches/images/gui/Makefile.in
===================================================================
--- /orxonox/branches/images/gui/Makefile.in	(revision 3104)
+++ /orxonox/branches/images/gui/Makefile.in	(revision 3105)
@@ -127,5 +127,4 @@
 PACKAGE_VERSION = @PACKAGE_VERSION@
 PATH_SEPARATOR = @PATH_SEPARATOR@
-PKG_CONFIG = @PKG_CONFIG@
 SET_MAKE = @SET_MAKE@
 SHELL = @SHELL@
Index: /orxonox/branches/images/importer/Makefile.in
===================================================================
--- /orxonox/branches/images/importer/Makefile.in	(revision 3104)
+++ /orxonox/branches/images/importer/Makefile.in	(revision 3105)
@@ -121,5 +121,4 @@
 PACKAGE_VERSION = @PACKAGE_VERSION@
 PATH_SEPARATOR = @PATH_SEPARATOR@
-PKG_CONFIG = @PKG_CONFIG@
 SET_MAKE = @SET_MAKE@
 SHELL = @SHELL@
Index: /orxonox/branches/images/src/Makefile.in
===================================================================
--- /orxonox/branches/images/src/Makefile.in	(revision 3104)
+++ /orxonox/branches/images/src/Makefile.in	(revision 3105)
@@ -136,5 +136,4 @@
 PACKAGE_VERSION = @PACKAGE_VERSION@
 PATH_SEPARATOR = @PATH_SEPARATOR@
-PKG_CONFIG = @PKG_CONFIG@
 SET_MAKE = @SET_MAKE@
 SHELL = @SHELL@