Index: code/trunk/src/orxonox/objects/worldentities/Attacher.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/Attacher.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/Attacher.cc	(revision 3110)
@@ -27,5 +27,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "Attacher.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/Backlight.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/Backlight.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/Backlight.cc	(revision 3110)
@@ -27,5 +27,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "Backlight.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/BigExplosion.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/BigExplosion.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/BigExplosion.cc	(revision 3110)
@@ -27,5 +27,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "BigExplosion.h"
 #include "MovableEntity.h"
Index: code/trunk/src/orxonox/objects/worldentities/Billboard.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/Billboard.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/Billboard.cc	(revision 3110)
@@ -27,5 +27,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "Billboard.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/BlinkingBillboard.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/BlinkingBillboard.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/BlinkingBillboard.cc	(revision 3110)
@@ -27,5 +27,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "BlinkingBillboard.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/Camera.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/Camera.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/Camera.cc	(revision 3110)
@@ -27,5 +27,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "Camera.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/CameraPosition.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/CameraPosition.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/CameraPosition.cc	(revision 3110)
@@ -27,5 +27,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "CameraPosition.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/ControllableEntity.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/ControllableEntity.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/ControllableEntity.cc	(revision 3110)
@@ -27,5 +27,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "ControllableEntity.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/ExplosionChunk.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/ExplosionChunk.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/ExplosionChunk.cc	(revision 3110)
@@ -27,5 +27,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "ExplosionChunk.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/FadingBillboard.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/FadingBillboard.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/FadingBillboard.cc	(revision 3110)
@@ -27,5 +27,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "FadingBillboard.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/Light.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/Light.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/Light.cc	(revision 3110)
@@ -27,5 +27,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "Light.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/MobileEntity.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/MobileEntity.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/MobileEntity.cc	(revision 3110)
@@ -27,5 +27,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "MobileEntity.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/Model.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/Model.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/Model.cc	(revision 3110)
@@ -27,5 +27,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 
 #include <OgreEntity.h>
Index: code/trunk/src/orxonox/objects/worldentities/MovableEntity.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/MovableEntity.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/MovableEntity.cc	(revision 3110)
@@ -28,5 +28,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "MovableEntity.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/ParticleEmitter.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/ParticleEmitter.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/ParticleEmitter.cc	(revision 3110)
@@ -32,5 +32,4 @@
 */
 
-#include "OrxonoxStableHeaders.h"
 #include "ParticleEmitter.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/ParticleSpawner.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/ParticleSpawner.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/ParticleSpawner.cc	(revision 3110)
@@ -27,5 +27,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "ParticleSpawner.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/Planet.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/Planet.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/Planet.cc	(revision 3110)
@@ -27,5 +27,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "Planet.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/PongBall.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/PongBall.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/PongBall.cc	(revision 3110)
@@ -27,5 +27,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "PongBall.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/PongBat.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/PongBat.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/PongBat.cc	(revision 3110)
@@ -27,5 +27,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "PongBat.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/PongCenterpoint.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/PongCenterpoint.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/PongCenterpoint.cc	(revision 3110)
@@ -27,5 +27,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "PongCenterpoint.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/SpawnPoint.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/SpawnPoint.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/SpawnPoint.cc	(revision 3110)
@@ -27,5 +27,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "SpawnPoint.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/StaticEntity.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/StaticEntity.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/StaticEntity.cc	(revision 3110)
@@ -28,5 +28,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "StaticEntity.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/TeamSpawnPoint.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/TeamSpawnPoint.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/TeamSpawnPoint.cc	(revision 3110)
@@ -27,5 +27,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "TeamSpawnPoint.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/WorldEntity.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/WorldEntity.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/WorldEntity.cc	(revision 3110)
@@ -28,5 +28,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "WorldEntity.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/pawns/Destroyer.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/pawns/Destroyer.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/pawns/Destroyer.cc	(revision 3110)
@@ -27,5 +27,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "Destroyer.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/pawns/Pawn.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/pawns/Pawn.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/pawns/Pawn.cc	(revision 3110)
@@ -27,5 +27,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "Pawn.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/pawns/SpaceShip.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/pawns/SpaceShip.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/pawns/SpaceShip.cc	(revision 3110)
@@ -27,5 +27,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "SpaceShip.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/pawns/Spectator.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/pawns/Spectator.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/pawns/Spectator.cc	(revision 3110)
@@ -27,5 +27,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "Spectator.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/triggers/CheckPoint.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/triggers/CheckPoint.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/triggers/CheckPoint.cc	(revision 3110)
@@ -27,5 +27,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "CheckPoint.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/triggers/DistanceTrigger.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/triggers/DistanceTrigger.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/triggers/DistanceTrigger.cc	(revision 3110)
@@ -27,5 +27,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "DistanceTrigger.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/triggers/EventTrigger.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/triggers/EventTrigger.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/triggers/EventTrigger.cc	(revision 3110)
@@ -27,5 +27,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "EventTrigger.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/triggers/PlayerTrigger.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/triggers/PlayerTrigger.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/triggers/PlayerTrigger.cc	(revision 3110)
@@ -33,5 +33,4 @@
 */
 
-#include "OrxonoxStableHeaders.h"
 #include "PlayerTrigger.h"
 
Index: code/trunk/src/orxonox/objects/worldentities/triggers/Trigger.cc
===================================================================
--- code/trunk/src/orxonox/objects/worldentities/triggers/Trigger.cc	(revision 3108)
+++ code/trunk/src/orxonox/objects/worldentities/triggers/Trigger.cc	(revision 3110)
@@ -27,5 +27,4 @@
  */
 
-#include "OrxonoxStableHeaders.h"
 #include "Trigger.h"
 